/*
 * frontier client string-key hashtable implementation
 * 
 * Author: Dave Dykstra
 *
 * $Id: fn-hash.c,v 1.1 2008/02/14 20:27:29 dwd Exp $
 *
 *  Copyright (C) 2008  Fermilab
 *
 *  This program is free software: you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  as published by the Free Software Foundation, either version 3 of
 *  the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this program.  If not, see
 *  <http://www.gnu.org/licenses/>.
 *
 */

 
#include "fn-hash.h"
#include <string.h>

#include "chashtable/hashtable.c"

DEFINE_HASHTABLE_INSERT(fn_hashtable_insert,char,fn_hashval)
DEFINE_HASHTABLE_SEARCH(fn_hashtable_search,char,fn_hashval)

static unsigned int
hashfromkey(void *k)
 {
  // This is the sdbm algorithm, generally praised on the internet as
  //  a good string hash
  unsigned int hash=0;
  unsigned char ch,*p=k;
  while((ch=*p++)!=0)
    hash=ch+(hash<<6)+(hash<<16)-hash;
  return hash;
 }

static int
equalkeys(void *k1,void *k2)
 {
  return(strcmp((char *)k1,(char *)k2)==0);
 }

fn_hashtable *
fn_inithashtable()
 {
  return(create_hashtable(256,hashfromkey,equalkeys));
 }
